import os
from pathlib import Path

import pytest
from rdflib import URIRef

from rdfdb.file_vs_uri import correctToTopdirPrefix, fileForUri, uriFromFile

demoMap = {Path('/tmp'): URIRef('http://example.com/myroot')}


def test_uriFromFile():
    assert uriFromFile(demoMap, Path('/tmp/foo/bar.n3')) == URIRef('http://example.com/myroot/foo/bar')


def test_fileForUri():
    assert fileForUri(demoMap, URIRef('http://example.com/myroot/where/to/save/this')) == Path('/tmp/where/to/save/this.n3')
    with pytest.raises(NotImplementedError):
        fileForUri(demoMap, URIRef('http://example.com/myroot/where/to/save/this/'))


def test_correctToTopdirPrefix():
    os.chdir('/tmp')
    assert correctToTopdirPrefix(demoMap, Path("/tmp/foo.n3")) == Path("/tmp/foo.n3")
    # todo: something to do with relative paths
