import unittest

from rdfdb.syncedgraph.grapheditapi import GraphEditApi
from rdflib import ConjunctiveGraph, URIRef


class TestPatchSubgraph(unittest.TestCase):

    def testCollapsesIdenticalQuads(self):
        appliedPatches = []

        class Obj(GraphEditApi):

            def __init__(self):
                pass

            def patch(self, p):
                appliedPatches.append(p)

            _graph: ConjunctiveGraph

        obj = Obj()
        obj._graph = ConjunctiveGraph()
        stmt1 = (URIRef('s'), URIRef('p'), URIRef('o'), URIRef('g'))
        obj._graph.addN([stmt1])
        obj.patchSubgraph(URIRef('g'), [stmt1])
        self.assertEqual(len(appliedPatches), 1)
        p = appliedPatches[0]
        self.assertTrue(p.isNoop())
        self.assertEqual(p.jsonRepr, '{"patch": {"adds": "", "deletes": ""}}')
